'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function plugin(Vue) {

    if (plugin.installed) {
        return;
    }

    var events = new Vue({
        methods: {
            fire: function fire(name) {
                var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

                this.emit(name, data);
            },
            emit: function emit(name) {
                var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

                this.$emit(name, data);
            },
            listen: function listen(name, cb) {
                this.on(name, cb);
            },
            on: function on(name, cb) {
                this.$on(name, cb);
            }
        }
    });

    Object.defineProperty(Vue.prototype, '$events', {
        get: function get() {
            return events;
        }
    });

    Vue.mixin({
        beforeCreate: function beforeCreate() {
            var _this = this;

            if (_typeof(this.$options.events) != 'object') return;

            this.$on('hook:beforeMount', function () {
                for (var key in _this.$options.events) {
                    events.on(key, _this.$options.events[key].bind(_this));
                }
            });
        }
    });
}

if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(plugin);
}

exports.default = plugin;